@use '../../src/stylesheets/core/breakpoints' as bp;
@use './hljs';

@mixin sb-outline($color) {

  // Hack to handle contained elements margins
  overflow: auto;
  box-shadow: inset 0 0 0 1px $color;
}

.doc-page {
  $viewport-height: calc(100vh - var(--navbar-height) - 2 * var(--spacer-default));

  display: grid;
  background: var(--background-color-alt);
  gap: var(--spacer-default);
  grid-template-columns: 250px auto;

  &__content {
    max-height: $viewport-height;
    padding: 0 var(--spacer-default) 3em var(--spacer-default);
    border-radius: var(--border-radius);
    margin: var(--spacer-default) var(--spacer-default) var(--spacer-default) 0;
    background: var(--background-color);
    overflow-y: auto;
  }

  &__menu {
    max-height: $viewport-height;
    margin: var(--spacer-default) 0 var(--spacer-default) var(--spacer-default);
    font-size: var(--font-size-smaller);
    overflow-y: auto;

    .rui-menu {
      border: none;
      border-radius: var(--border-radius);
      background: var(--background-color);

      &-item {
        &.router-link-exact-active {
          color: var(--primary-color)
        }
      }
    }
  }
}

.doc-scroll-to-top {
  position: fixed;
  bottom: var(--spacer-medium);
  left: 50%;
  display: inline-block;
  padding: var(--spacer-small);
  border-radius: var(--border-radius);
  background: var(--component-content-background);
  opacity: 0.5;
  transform: translateX(50%);
  transition: opacity linear 0.2s;

  button {
    border-radius: var(--border-radius-small);
  }

  &:hover{
    box-shadow: 0 0 5px var(--popper-theme-box-shadow);
    opacity: 1;
  }
}

.doc-markdown{
  margin-bottom: var(--spacer-default);

  &__toc {
    position: sticky;
    top: 0;

    &__content {
      font-size: var(--font-size-smaller);

      ol, ul {
        padding: 0;
        margin: 0;

        ol, ul {
          padding-left: var(--spacer-default);
        }

        a {
          display: block;
          padding: var(--spacer-tiny) var(--spacer-default);
          color: var(--foreground-color);

          &:hover {
            background: var(--background-color-alt);
          }
        }
      }
    }
  }

  &__content {
    padding-left: var(--spacer-medium);

    h1,h2,h3,h4,h5,h6{
      display: flex;
      align-items: center;
      gap: var(--spacer-default);
    }
  }

  &--toc {
    display: grid;
    grid-gap: var(--spacer-default);
    grid-template-columns: 1fr 6fr;
  }
}

.-doc-permalink {

  // Goes well with the gap between content and toc
  position: relative;
  margin-left: calc(0px - var(--spacer-medium));
  color: var(--state-color-mute);
  font-size: var(--font-size-base);

  &:visited {
    color: var(--state-color-mute);
  }

  &:hover {
    color: var(--link-color);
  }
}

.doc-source {
  $background: var(--background-color-alt);

  border-radius: var(--border-radius);
  margin: var(--spacer-default) 0;
  font-size: var(--font-size-smaller);

  &__actions{
    display: inline-block;
    padding: var(--spacer-small);
    border-radius: var(--border-radius) var(--border-radius) 0 0;
    background: $background;
  }

  &__content {
    padding: var(--spacer-default);
    border-radius: 0 var(--border-radius) var(--border-radius) var(--border-radius);
    background: $background;
    font-size: var(--font-size-smaller);
    overflow-x: auto;
  }
}

.doc-example {
  padding: var(--spacer-tiny);
  border-radius: var(--border-radius);
  background: var(--background-color-alt);

  &__actions.rui-toolbars {
    display: inline-flex;
    height: unset;
    padding: var(--spacer-tiny);
    border-radius: var(--border-radius-small) var(--border-radius-small) 0 0;
    background: var(--background-color);
  }

  &__wrapper {
    padding: var(--spacer-default);
    border-radius: 0 var(--border-radius-small) var(--border-radius-small) var(--border-radius);
    background: var(--background-color);
    box-shadow: 0 0 20px -5px var(--border-color);
  }

  &__content {
    border: 1px dashed transparent;
    background-color: var(--background-color);

    &--outline {
      > * {
        box-shadow: 0 0 0 1px #7400D9 !important; // stylelint-disable-line declaration-no-important

        > * {
          box-shadow: 0 0 0 1px #0074D9 !important; // stylelint-disable-line declaration-no-important

          > * {
            box-shadow: 0 0 0 1px #74D900 !important; // stylelint-disable-line declaration-no-important
          }
        }
      }
    }

    &--checkered { background-image: var(--background-checked); }

    &--padded { padding: var(--spacer-default); }

    &--tiny { max-width: calc(#{bp.$small} - 10px); }
    &--small { max-width: bp.$small; }
    &--medium { max-width: bp.$medium; }
    &--large { max-width: bp.$large; }
  }

  &__aside {
    > pre {
      border-top-left-radius: 0;
      border-top-right-radius: 0;
    }
  }
}

.-doc-outline {
  @include sb-outline(#D97400);


  &--alt {
    @include sb-outline(#D90074);
  }
}

.-doc-spacer {
  background-color: var(--state-color-mute-alt);
  background-image: linear-gradient(
      135deg,
      transparent,
      transparent 5px,
      var(--state-color-mute) 5px,
      var(--state-color-mute) 6px,
      transparent 6px,
      transparent 100%
  );
  background-size: 8px 8px;
  box-shadow: 0 1px 0 0 currentcolor, 0 -1px 0 0 currentcolor;
}

@each $height in (100, 200) {
  .-doc-h#{$height} {
    height: #{$height}px;
    overflow-y: auto;
  }
}
